using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection; 

namespace AnalogOutput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }      
       
        ushort wTotalBoard, wRtn, wBoardNo;
       
        const uint MAX_DATA_NUM = 512; 
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[UniDAQ.MAX_BOARD_NUMBER];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[UniDAQ.MAX_BOARD_NUMBER];
        float[] fDABuf = new float[MAX_DATA_NUM];
        float fRangeMax, fRangeMin;
        
        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Initial Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }

        }     

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            //Total Analog Output Channel

            cbxChannel.Items.Clear();
            if (sCardInfo[wBoardNo].wAOChannels>0)
            {
                for (int wChannelIndex = 0; wChannelIndex < sCardInfo[wBoardNo].wAOChannels; wChannelIndex++)
                {
                    cbxChannel.Items.Add("Channel " + wChannelIndex.ToString());
                }

                cbxChannel.SelectedIndex = 0;
            }


            this.Text = this.cbxSelBoard.Text + " Analog Output Pattern Generator(Cont.) Sample Program";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Driver Close
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            if (btnOutput.Text == "&ACTIVE")
            {
                btnOutput.Text = "&STOP";

                //SinWave Pattern
                for (UInt16 wIndex = 0; wIndex < MAX_DATA_NUM; wIndex++)
                {
                    fDABuf[wIndex] = Convert.ToSingle(this.tbxAOAMP.Text) * (float)(Math.Sin((Math.PI / 180.0) * (double)wIndex * (360.0 / 512.0))) + Convert.ToSingle(this.tbxOffset.Text);

                    //fDABuf[wIndex] = (float)(wIndex / 100.0);
                }
                wBoardNo  = (ushort)cbxSelBoard.SelectedIndex;
                //Config Analog Output Range
                wRtn = UniDAQ.Ixud_ConfigAO(wBoardNo, (ushort)cbxChannel.SelectedIndex, (ushort)cbxConfig.SelectedIndex);
                
                //Write the Analog Output Value for Voltage
                wRtn = UniDAQ.Ixud_StartAOVoltage(wBoardNo, (ushort)cbxChannel.SelectedIndex, (ushort)cbxChannel.SelectedIndex, Convert.ToSingle(this.tbxRate.Text) * (float)1000.0, MAX_DATA_NUM, 0, fDABuf);
            }
            else
            {
                btnOutput.Text = "&ACTIVE";
                wRtn = UniDAQ.Ixud_StopAO(wBoardNo, (ushort)cbxChannel.SelectedIndex);
            }

            while (btnOutput.Text == "&STOP")
            {
                Application.DoEvents();
            }           
        }

        private void cbxConfig_SelectedIndexChanged(object sender, EventArgs e)
        {
          
            switch (cbxConfig.SelectedIndex)
            {
                case UniDAQ.IXUD_AO_BI_10V:
                    fRangeMax = 10.0F;
                    fRangeMin = -10.0F;
                    break;

                case UniDAQ.IXUD_AO_BI_20V:
                    //1 //Bipolar +/- 5V 
                    fRangeMax = 20.0F;
                    fRangeMin = -20.0F;
                    break;

                case UniDAQ.IXUD_AO_BI_5V:
                    //2 //Bipolar +/- 2.5V 
                    fRangeMax = 5.0F;
                    fRangeMin = -5.0F;
                    break;

                case UniDAQ.IXUD_AO_UNI_10V:
                    //3 //Bipolar +/- 1.25V 
                    fRangeMax = 10.0F;
                    fRangeMin = 0.0F;
                    break;

                case UniDAQ.IXUD_AO_UNI_20V:
                    //4 //Bipolar +/- 0.625V 
                    fRangeMax = 20.0F;
                    fRangeMin = 0.0F;
                    break;

                case UniDAQ.IXUD_AO_UNI_5V:
                    //5 //Bipolar +/- 0.3125V 
                    fRangeMax = 5.0F;
                    fRangeMin = 0.0F;
                    break;         
            }

            this.tbxAOAMP.Text = Convert.ToString(fRangeMax);


                   
        }
    } 
}