using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace AnalogOutput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();


        }
      
       
        ushort wTotalBoard, wRtn, wBoardNo;
       
       
        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[32];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[32];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (ushort wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }
        }     

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
              
            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;
            //Total Analog Output Channel

            cbxChannel.Items.Clear();
            if (sCardInfo[wBoardNo].wAOChannels>0)
            {
                for (int wChannelIndex = 0; wChannelIndex < sCardInfo[wBoardNo].wAOChannels; wChannelIndex++)
                {
                    cbxChannel.Items.Add("Channel " + wChannelIndex.ToString());
                }

                cbxChannel.SelectedIndex = 0;
            }


            this.Text = this.cbxSelBoard.Text + " Analog Output Voltage Sample Program";
        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Driver Close
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
            
            wBoardNo  = (ushort)cbxSelBoard.SelectedIndex;
            //Config Analog Output Range
            wRtn = UniDAQ.Ixud_ConfigAO(wBoardNo, (ushort)cbxChannel.SelectedIndex, (ushort)cbxConfig.SelectedIndex);
            //Write the Analog Output Value for Voltage
            wRtn = UniDAQ.Ixud_WriteAOVoltage(wBoardNo, (ushort)cbxChannel.SelectedIndex, Convert.ToSingle(tbxValue.Text));
        }



    } 
}