using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;

using System.Resources; 
using System.Collections; 
using System.Threading;
using System.Runtime.InteropServices;
using controlArray; //namespace ControlArray
using UniDAQ_Ns;
using System.Reflection;    //namespace P100X_Ns 

namespace AnalogOutput
{
    public partial class Form1 : Form
    {
        public Form1()
        {
            InitializeComponent();
        }
      
       
        ushort wTotalBoard, wRtn, wBoardNo;
        Single fFrequency;
        ushort wStatus;
        UInt32 dwCounter;

        UniDAQ.IXUD_CARD_INFO[] sCardInfo = new UniDAQ.IXUD_CARD_INFO[32];
        UniDAQ.IXUD_DEVICE_INFO[] sDeviceInfo = new UniDAQ.IXUD_DEVICE_INFO[32];

        private void Form1_Load(object sender, EventArgs e)
        {

            byte[] szModeName = new byte[20];
            ushort wBoardIndex;
            ushort wChannelIndex;
            //Driver Initial
            wRtn = UniDAQ.Ixud_DriverInit(ref wTotalBoard);
            if (wRtn != UniDAQ.Ixud_NoErr)
            {
                MessageBox.Show("Driver Inital Error!!Error Code:"+wTotalBoard.ToString());
                Close();
                return;
            }

            for (wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            { 
                //Get Card Information
                wRtn = UniDAQ.Ixud_GetCardInfo(wBoardIndex, ref sDeviceInfo[wBoardIndex], ref sCardInfo[wBoardIndex], szModeName);
                this.cbxSelBoard.Items.Add(Encoding.ASCII.GetString(szModeName));
            }

            cbxSelBoard.SelectedIndex = 0;
          

            for (wBoardIndex = 0; wBoardIndex < wTotalBoard; wBoardIndex++)
            {
                for (wChannelIndex = 0; wChannelIndex <= 15; wChannelIndex++)
                {
                    wRtn = UniDAQ.Ixud_SetFCChannelMode(wBoardIndex, wChannelIndex, 3, 20); //Read Counter Mode
                }
            }

        }

        private void btnExit_Click(object sender, EventArgs e)
        {
            //Driver Close
            wRtn = UniDAQ.Ixud_DriverClose();
            Close();
        }

        private void btnOutput_Click(object sender, EventArgs e)
        {
                    
            ushort wChannelIndex;
            ushort wDelayMs;
            

            wBoardNo  = (ushort)cbxSelBoard.SelectedIndex;
            wDelayMs = System.Convert.ToUInt16(DelayMs.Text);

            if ((sCardInfo[wBoardNo].wCounterChannels) == 0)
            {
                MessageBox.Show ("Not support timer counter");
                Close();
                return;
            }

            listBox1.Items.Clear();

            for (wChannelIndex = 0; wChannelIndex <= 15; wChannelIndex++)
            {
                wRtn = UniDAQ.Ixud_ReadCounter(wBoardNo, wChannelIndex, ref dwCounter); //Read Counter
                if (wRtn != UniDAQ.Ixud_NoErr)
                {
                    MessageBox.Show("Error!!Error Code:" + wRtn);
                    Close();
                    return;
                }

                listBox1.Items.Add("Channel " + wChannelIndex + ";  [ " + dwCounter +" ]");

            }
        }

        private void cbxSelBoard_SelectedIndexChanged(object sender, EventArgs e)
        {
            ushort i;

            this.Text = this.cbxSelBoard.Text + " Timer Counter";


            wBoardNo = (ushort)cbxSelBoard.SelectedIndex;

            //whether have the timer counter
            if ((sCardInfo[wBoardNo].wCounterChannels) == 0)
            {
                MessageBox.Show("Not support timer counter");
                btnOutput.Enabled = false;
            }
            else
            { 
                btnOutput.Enabled = true;

            }
        }

    } 
}