VERSION 5.00
Begin VB.Form DIO_LED 
   Caption         =   "Digital I/O LED"
   ClientHeight    =   4200
   ClientLeft      =   60
   ClientTop       =   465
   ClientWidth     =   3810
   LinkTopic       =   "Form1"
   ScaleHeight     =   4200
   ScaleWidth      =   3810
   StartUpPosition =   3  'Windows Default
   Begin VB.ComboBox cbxTrigger 
      BackColor       =   &H0080FF80&
      Height          =   315
      ItemData        =   "Counter_Int_Callback.frx":0000
      Left            =   1440
      List            =   "Counter_Int_Callback.frx":000D
      TabIndex        =   6
      Text            =   "--------------------------"
      Top             =   2520
      Width           =   1815
   End
   Begin VB.TextBox tbxAPCCount 
      BackColor       =   &H00C0FFFF&
      Height          =   375
      Left            =   1440
      TabIndex        =   4
      Text            =   "0"
      Top             =   3000
      Width           =   1815
   End
   Begin VB.ListBox lstMsg 
      BackColor       =   &H00C0FFFF&
      Enabled         =   0   'False
      Height          =   2010
      ItemData        =   "Counter_Int_Callback.frx":0043
      Left            =   0
      List            =   "Counter_Int_Callback.frx":005C
      TabIndex        =   3
      Top             =   0
      Width           =   3615
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "&EXIT"
      Height          =   615
      Left            =   2040
      TabIndex        =   2
      Top             =   3480
      Width           =   1695
   End
   Begin VB.ComboBox cbxBoardNo 
      BackColor       =   &H0080FF80&
      Height          =   315
      Left            =   0
      TabIndex        =   1
      Text            =   "-----Select Board-----"
      Top             =   2040
      Width           =   3615
   End
   Begin VB.CommandButton cmdActive 
      Caption         =   "&ACTIVE"
      Height          =   615
      Left            =   0
      TabIndex        =   0
      Top             =   3480
      Width           =   1935
   End
   Begin VB.Label Label2 
      Caption         =   "Trigger Edge"
      Height          =   375
      Left            =   120
      TabIndex        =   7
      Top             =   2520
      Width           =   1215
   End
   Begin VB.Label Label1 
      Caption         =   "Interrupt Count"
      Height          =   375
      Left            =   120
      TabIndex        =   5
      Top             =   3000
      Width           =   1095
   End
End
Attribute VB_Name = "DIO_LED"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit
Dim wTotalBoards As Integer
Dim wBoardNo As Integer
Dim wOutputPortNo, wInputPortNo As Integer
Dim wRtn As Integer
Dim wPortChNum As Integer

Dim sDevInfo(0 To MAX_BOARD_NUMBER - 1) As IXUD_DEVICE_INFO
Dim sCardInfo(0 To MAX_BOARD_NUMBER - 1) As IXUD_CARD_INFO
Dim sSelDevInfo As IXUD_DEVICE_INFO
Dim sSelCardInfo As IXUD_CARD_INFO


Private Sub cbxBoardNo_Click()

Dim PortIndex As Integer
wBoardNo = cbxBoardNo.ListIndex
sSelDevInfo = sDevInfo(wBoardNo)
sSelCardInfo = sCardInfo(wBoardNo)
 
wPortChNum = sCardInfo(wBoardNo).wDIOPortWidth

DIO_LED.Caption = Me.cbxBoardNo.Text + " CTR Int Callback "
End Sub

Private Sub cmdActive_Click()

Dim hEvent As Long
Dim i As Integer
Dim ApcReg As Long
Dim wTriggerMode As Integer

If cmdActive.Caption = "&ACTIVE" Then


    wBoardNo = Val(Me.cbxBoardNo.ListIndex)
    
    hEvent = 0 '//Initial hEvent
    
    
    wApcCount = 0 '//Callback function count for Int Source 0
    
     cmdActive.Caption = "&STOP"
     
     Select Case Me.cbxTrigger.ListIndex
     
     Case 0
        wTriggerMode = IXUD_HARDWARE_INT Or IXUD_ACTIVE_LOW
     
     Case 1
      wTriggerMode = IXUD_HARDWARE_INT Or IXUD_ACTIVE_HIGH
     
     Case 2
     
     wTriggerMode = IXUD_HARDWARE_INT Or IXUD_ACTIVE_LOW Or IXUD_ACTIVE_HIGH
     End Select
     
     
    
    '//Register Callback function, Source = 1(INT_0)
    wRtn = Ixud_SetEventCallback(wBoardNo, wTriggerMode, 1, 0, AddressOf MyApcFunction, 0) '//Register APC
    
    If wRtn <> 0 Then
        lstMsg.AddItem "Register APC Error!!"
    Else
        lstMsg.AddItem " Register APC OK!!!"
    End If
    
    
    '//Install IRQ number
    wRtn = Ixud_InstallIrq(wBoardNo, &H1)
    If wRtn Then
        lstMsg.AddItem ("Install IRQ Error")
    Else
        lstMsg.AddItem ("Install IRQ Success!!!")
    End If
    

'//Set Count 3 to Mode 3 Generate 80000/40000 = 2Hz Clock
wRtn = Ixud_SetCounter(wBoardNo, 2, 3, 40000)
Else
 cmdActive.Caption = "&ACTIVE"
 lstMsg.AddItem " Stop Counter Trigger"
'//Stop Counter
wRtn = Ixud_SetCounter(wBoardNo, 2, 2, 1)
 '// Revmove the Interrupt
 wRtn = Ixud_RemoveIrq(wBoardNo)
 lstMsg.AddItem "Stop Interrupt!!"

 wRtn = Ixud_RemoveEventCallback(wBoardNo, 0) '//Remove APC
 lstMsg.AddItem "Remove APC!!"
 
 lstMsg.AddItem "Event Count" + Str(wApcCount)

End If


While Me.cmdActive.Caption = "&STOP"


Me.tbxAPCCount.Text = CStr(wApcCount)
        

   DoEvents

Wend





End Sub

Private Sub cmdExit_Click()
 Call Ixud_DriverClose
 End
End Sub

Private Sub Form_Load()
Dim wBoardIndex As Integer
Dim szModelName As String * 20

'//Driver Initial
wRtn = Ixud_DriverInit(wTotalBoards)
If (wRtn) Then
    MsgBox ("Driver Initial Error!!Error Code:" + Str(wRtn))
    End
End If

'//Get Card Information
For wBoardIndex = 0 To wTotalBoards - 1

    wRtn = Ixud_GetCardInfo(wBoardIndex, sDevInfo(wBoardIndex), sCardInfo(wBoardIndex), szModelName)
    
    If (wRtn) Then
        MsgBox ("Get Card Information Err")
    End If
    
    Me.cbxBoardNo.AddItem Str(wBoardIndex) + " " + szModelName

Next

Me.cbxBoardNo.ListIndex = 0
Me.cbxTrigger.ListIndex = 0
    
End Sub
