// DIODlg.cpp : implementation file
//

#include "stdafx.h"
#include "Test.h"
#include "TestDlg.h"
#include "UniDAQ.h"
#pragma comment(lib,"UniDAQ.lib")

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

WORD wRtn;
WORD wBoardNo;

IXUD_DEVICE_INFO sDevInfo[MAX_BOARD_NUMBER];
IXUD_CARD_INFO sCardInfo[MAX_BOARD_NUMBER];
char szModelName[20]="Unknow Device";
/////////////////////////////////////////////////////////////////////////////
// CDIODlg dialog

CDIODlg::CDIODlg(CWnd* pParent /*=NULL*/)
	: CDialog(CDIODlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CDIODlg)
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CDIODlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CDIODlg)
	DDX_Control(pDX, IDC_COMBO_SelectBoard, m_IDC_COMBO_SelectBoard);
	DDX_Control(pDX, Channel, m_Channel);

	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CDIODlg, CDialog)
	//{{AFX_MSG_MAP(CDIODlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BTN_DO, OnBtnDo)
	ON_CBN_SELCHANGE(IDC_COMBO_SelectBoard, OnSelchangeCOMBOSelectBoard)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CDIODlg message handlers

BOOL CDIODlg::OnInitDialog()
{
	WORD wTotalBoards;
	CDialog::OnInitDialog();
	CString str;
	

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	//Initial the resource form  Driver
	wRtn=Ixud_DriverInit(&wTotalBoards);
	if (wRtn!=0) 
	{	MessageBox("Driver Initial Error!!");
		return wRtn;
	}

	m_IDC_COMBO_SelectBoard.Clear();
	
	//Get Card Information
	for(WORD wBoardIndex = 0; wBoardIndex<wTotalBoards ; wBoardIndex++)
	{
		wRtn = Ixud_GetCardInfo(wBoardIndex,&sDevInfo[wBoardIndex],&sCardInfo[wBoardIndex],szModelName);
		 
		m_IDC_COMBO_SelectBoard.AddString(szModelName);	
	}

	//Set initial value
	SetDlgItemText(Value, "40000");
	((CComboBox*)GetDlgItem(Mode))->AddString("0");
	((CComboBox*)GetDlgItem(Mode))->AddString("1");
	((CComboBox*)GetDlgItem(Mode))->AddString("2");
	((CComboBox*)GetDlgItem(Mode))->AddString("3");
	((CComboBox*)GetDlgItem(Mode))->AddString("4");
	((CComboBox*)GetDlgItem(Mode))->AddString("5");
	((CComboBox*)GetDlgItem(Mode))->SetCurSel(2);
	(GetDlgItem(IDC_BTN_DO))->EnableWindow(FALSE);
	
	// TODO: Add extra initialization here
	
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CDIODlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CDIODlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

void CDIODlg::OnBtnDo() 
{  
	// TODO: Add your control notification handler code here
	WORD wCounterCh,wCounterMode,i;
	unsigned long wCounterValue;
	CString str;

	((CListBox*)GetDlgItem(IDC_LIST1))->ResetContent();

	GetDlgItemText(Value,str);
	wCounterValue=atol(str);
	wCounterCh=((CComboBox*)GetDlgItem(Channel))->GetCurSel();
	wCounterMode=((CComboBox*)GetDlgItem(Mode))->GetCurSel();

	//Set timer counter
	Ixud_SetCounter(wBoardNo, wCounterCh, wCounterMode, wCounterValue);

	//Read timer counter
	for(i=0;i<100;i++)
	{
		Ixud_ReadCounter(wBoardNo, wCounterCh, &wCounterValue);
		str.Format(_T("%ld"),wCounterValue);
	    ((CListBox*)GetDlgItem(IDC_LIST1))->AddString(str);
	}
} 


void CDIODlg::OnSelchangeCOMBOSelectBoard() 
{
	// TODO  Add your control notification handler code here
	int i;
	CString str;

    m_Channel.ResetContent();
	
	wBoardNo = m_IDC_COMBO_SelectBoard.GetCurSel();

	//whether have the timer counter
	if (sCardInfo[wBoardNo].wCounterChannels == 0)
	{ 
		MessageBox("Not support timer counter");
		(GetDlgItem(IDC_BTN_DO))->EnableWindow(FALSE);
	}
	else
	{
		for(i=0;i<sCardInfo[wBoardNo].wCounterChannels;i++)
		{
			str.Format(_T("%d"),i);
			m_Channel.AddString(str);
		}	

		m_Channel.SetCurSel(0);
		(GetDlgItem(IDC_BTN_DO))->EnableWindow(TRUE);
	}

}

void CDIODlg::OnCancel() 
{
	// TODO: Add extra cleanup here
	wRtn = Ixud_DriverClose();
	CDialog::OnCancel();
}


